﻿using Syncfusion.SfDataGrid.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace DataGridDemo
{
    public class ViewModel : INotifyPropertyChanged
    {
        OrderInfoRepository order;
        public ViewModel()
        {
            order = new OrderInfoRepository();
            _addRow = new Command(ExecuteAddRow);
            _addColumn = new Command(ExecuteAddColumn);
            SetRowstoGenerate(100);
        }

        #region Command methods

        private void ExecuteAddRow(object obj)
        {
            this.OrdersInfo.Insert(0,new OrderInfo() { OrderID = 10000, Country = "US", CustomerID = "Alfki",Freight = "345", IsClosed = true });
        }

        private void ExecuteAddColumn(object obj)
        {
            var dataGrid = obj as SfDataGrid;
            (obj as SfDataGrid).Columns.Insert(0,new GridTextColumn() { MappingName = "OrderID" });
        }

        #endregion

        #region Commands

        private Command _addRow;

        public Command AddRowCommand
        {
            get
            {
                return _addRow;
            }
            set
            {
                _addRow = value;
            }
        }

        private Command _addColumn;

        public Command AddColumnCommand
        {
            get
            {
                return _addColumn;
            }
            set
            {
                _addColumn = value;
            }
        }

        #endregion

        #region ItemsSource

        private ObservableCollection<OrderInfo> ordersInfo;

        public ObservableCollection<OrderInfo> OrdersInfo
        {
            get { return ordersInfo; }
            set { this.ordersInfo = value; RaisePropertyChanged("OrdersInfo"); }
        }

        #endregion

        #region ItemSource Generator

        public void SetRowstoGenerate(int count)
        {
            ordersInfo = order.GetOrderDetails(count);
        }

        #endregion

        #region INotifyPropertyChanged implementation

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}
